--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function initOptions()
	log("initOptions()");
	
	DCVGlobal["DCOptions"] = {};
	
	setupPageWelcome();
	setupPageMainbar();
	setupPageMap();
	setupPageMinimap();
	setupPageObjectivesTracker();
	setupPageOther();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function AddDCoordsOptionsTitles(targetFrame,titleExtension)
	targetFrame.MainTitle = targetFrame:CreateFontString("DCoordsPage1MainTitle", "OVERLAY")
	targetFrame.MainTitle:SetFont(getAddonDefaultFont(),24,"OUTLINE")
	targetFrame.MainTitle:SetTextColor(1,1,1)
	targetFrame.MainTitle:SetPoint("TOPLEFT", 10, -10)
      
      if (not titleExtension or titleExtension == "") then
	      targetFrame.MainTitle:SetText("DCoords v" .. DCoordsVersion);
      else
            targetFrame.MainTitle:SetText("DCoords v" .. DCoordsVersion .. "  -  " .. titleExtension);
      end
      
      targetFrame.subTitle = targetFrame:CreateFontString("DCoordsPage1subTitle", "OVERLAY")
	targetFrame.subTitle:SetFont(getAddonDefaultFont(),11,"OUTLINE")
	targetFrame.subTitle:SetTextColor(0.5,0.5,0.5)
	targetFrame.subTitle:SetPoint("TOPLEFT", 10, -30)
	targetFrame.subTitle:SetText("Darcey@AllForTheCode.co.uk");
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





