--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageWelcome()
	DCVGlobal["DCOptions"].Main = CreateFrame( "Frame", "DCoordsOptionsMainPage", UIParent );
	local frame = DCVGlobal["DCOptions"].Main;
	frame.name = "DCoords";
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"");
	
    -- Page of settings
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 200;
	local sliderWidth = 200;
	local msg = "";
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "Thanks for using DCoords v" .. tostring(DCoordsVersion) .. "!" .. "\n\n";
	msg = msg .. "What's new?" .. "\n";
	msg = msg .. "NEW: Minimap coordinates with font and font size settings available." .. "\n\n";
	msg = msg .. "NEW: Other tab now has addon update speed sliders, got a good computer use low values, got a potatoe use high values." .. "\n\n";
	msg = msg .. "NEW: Simpler options, some people are having trouble working out the addon, I've simplified the options a little.'" .. "\n\n";
	msg = msg .. "NEW: Additional optimisation for update processes, will help people with potatoes for computers." .. "\n";
	msg = msg .. "\n\n";
	msg = msg .. "USAGE GUIDE:" .. "\n\n";
	msg = msg .. "- To view options type /DC menu or right click on coordinates bar.";
	msg = msg .. "\n\n";
	msg = msg .. "- You can drag the coordinates bar by holding SHIFT, LEFT CLICK AND DRAG.";
	msg = msg .. "\n\n";
	msg = msg .. "- Objectives tracker features if enabled you can drag the objectives tracker by holding SHIFT + LEFT CLICK Title and DRAG.";
	msg = msg .. "\n\n";
	msg = msg .. "- Setting alignment of coordinates bar will change the way the coordinates bar grows and shrinks in width." .. "\n";
	msg = msg .. "If you align left (Top left, Left, Bottom left), the coordinates bar will expand to the right." .. "\n";
	msg = msg .. "If you align right (Top right, Right, Bottom right), the coordinates bar will expand to the left." .. "\n";
	msg = msg .. "If you align center (Top, Center, Bottom), the coordinates bar will expand both ways (DCoords version 3 behaviour).";
	msg = msg .. "\n\n";
	msg = msg .. "- If your having problems, RESET by either typing /DC reset or go to options > other and click on reset";
	msg = msg .. "\n\n"; 
	local mainInfo1 = createLabel("mainInfo1",frame,msg,14,1,1,1,1,"LEFT",px,py);
	py = py - 25;
	
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #