﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function log(arg1)
    if (DCoordsDebug) then
        print(tostring(arg1))
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function toChat(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- http://wowprogramming.com/docs/widgets/FontInstance/SetFont
-- Fonts\\FRIZQT__.TTF - Friz Quadrata, used by default for player names and most UI text
-- Fonts\\ARIALN.TTF - Arial Narrow, used by default for chat windows, action button numbers, etc.
-- Fonts\\skurri.ttf - Skurri, used by default for incoming damage/parry/miss/etc indicators on the Player and Pet frames
-- Fonts\\MORPHEUS.ttf - Morpheus, used by default for quest title headers, mail, and readable in-game objects.
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getSystemDefaultFont()
	return "Fonts\\FRIZQT__.TTF"
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getAddonDefaultFont()
	--return "Fonts\\FRIZQT__.TTF";
	local font = DCoordsLSM:Fetch("font","Font "..1,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMainFrameFont()
    --local f = 16;
	--log("Trying to find Font " .. DCoords_MainFrameFont);
	local font = DCoordsLSM:Fetch("font","Font "..DCoordsVDB["MainBar"].fontSelectedIndex,true);
    --log(fontFiles[f]);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMainFrameFontName()
    return "Font " .. tostring(DCoords_MainFrameFont);
	--return fontNames[DCoords_MainFrameFont]
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getFontAtIndex(index)
	local font = DCoordsLSM:Fetch("font","Font "..index,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMapFrameFont()
	local font = DCoordsLSM:Fetch("font","Font "..DCoordsVDB["WorldMap"].fontSelectedIndex,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMinimapFont()
	local font = DCoordsLSM:Fetch("font","Font "..DCoordsVDB["Minimap"].fontSelectedIndex,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMapFrameFontName()
	return fontFiles[DCoords_MapFrameFont]
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function invertBoolean(bool)
    if (bool == true) then
        return false;
    else
        return true;
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createText(frame,label,size,x,y)
    local cfs = frame:CreateFontString(nil, 'ARTWORK');
    cfs:SetPoint("TOPLEFT", x, y);
    cfs:SetFont(getAddonDefaultFont(), size,"OUTLINE");
    cfs:SetShadowOffset(1, -1);
    cfs:SetTextColor(1, 1, 1);
    cfs:SetNonSpaceWrap(false);
    cfs:SetText(label);
    return cfs;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createCheckbox(name,frameContainer,label,checked,x,y,clickHandler)
	local checkbox = CreateFrame("CheckButton", name, frameContainer);
	checkbox:SetWidth(20);
	checkbox:SetHeight(23);
	checkbox:SetPoint("TOPLEFT", x, y);
	
	checkbox:SetHitRectInsets(0, -200, 0, 0);
	checkbox:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
	checkbox:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
	checkbox:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight");
	checkbox:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
	
	local description = checkbox:CreateFontString(name.."Label", "ARTWORK", "GameFontHighlight");
	description:SetPoint("LEFT", checkbox, "RIGHT", 1, 1);
	description:SetText(label);
	description:SetTextColor(1,1,1);
	description:SetFont(getAddonDefaultFont(), DCVGlobal["DCUIFontSize"],"OUTLINE");
	description:SetJustifyH("LEFT");
    local txtW = description:GetStringWidth();
    checkbox:SetHitRectInsets(0, -txtW, 0, 0);
	
	-- Defaults
	checkbox:SetChecked(checked);
	
	checkbox:SetScript("OnClick", function(frame)
		clickHandler(frame:GetChecked());
		checked = frame:GetChecked();
		local tick = frame:GetChecked();
		if tick then
			playClick();
		else
			playClick();
		end
	end)	
	
	return checkbox;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

--function createSlider(frame,id,x,y,min,max,default,label,width,callBackFunction,decimals)
function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
	
    x = x +5;
	
	if (showEditBox == nil) then
		showEditBox = false;
	end
	
	local formattedDefaultValue = string.format("%."..decimalPrecision.."f",default);
	
	
	-- WARNING: ORDER HERE IS IMPORTANT ON CREATE FRAME (if slider is created 1st then clicks will not register on edit box)
	local editBox;
	local editBoxName = name .. "EditBox";
	local editBoxWidth = 30;
	
	--toChat(editBoxName .. " - step = " .. tostring(step));
	
	if (showEditBox == true) then
		editBox = CreateFrame("EditBox",editBoxName,frameContainer,"InputBoxTemplate");
		editBox:SetWidth(editBoxWidth);
		editBox:SetHeight(18);
		editBox:SetPoint("TOPLEFT", x+width-editBoxWidth, y-4);
		editBox:SetMaxLetters(6);
		editBox:SetMultiLine(false);
		editBox:SetAutoFocus(false);
		editBox:SetFont(getAddonDefaultFont(),12,"NONE");
		editBox:SetText("AFTC");
		editBox:SetText(formattedDefaultValue);
		editBox:HighlightText(0,0); 
		editBox:SetCursorPosition(0);
		editBox:ClearFocus();
	
	
		editBox:SetScript("OnEnterPressed", function(self)
			self:ClearFocus();
			changeHandler(self:GetNumber());
			if (self.sliderRef ~= nil) then
				self.sliderRef:SetValue(self:GetNumber());
			end
		end);
	end
	
	
	-- WARNING: ORDER HERE IS IMPORTANT ON CREATE FRAME (if slider is created 1st then clicks will not register on edit box)
	local slider = CreateFrame("Slider", name, frameContainer, "OptionsSliderTemplate");
	slider:ClearAllPoints();
	slider:SetPoint("TOPLEFT", x, y-20);
	slider:SetMinMaxValues(min,max);
	slider:SetValue(default);
    slider:SetOrientation('HORIZONTAL')
    slider:SetWidth(width);
    slider:SetHeight(18);
    slider:SetObeyStepOnDrag(true);
	slider:SetValueStep(step);
	
	if (showEditBox == true) then
		editBox.sliderRef = slider;
	end
	
	
    
	--log(slider:GetName());
	
	getglobal(name .. 'Low'):SetText(min);
	getglobal(name .. 'High'):SetText(max);
    
	local txt = getglobal(slider:GetName() .. 'Text');
	txt:SetText("");
	
	
	
	if (showEditBox == false) then
		if (label ~= "") then
			txt:SetText( label .. " " .. string.format("%."..decimalPrecision.."f",default) );
		else   
			txt:SetText( string.format("%."..decimalPrecision.."f",default) );
		end
	else 
		txt:SetText( label );
	end
	
	
    
    getglobal(slider:GetName() .. 'Low'):SetFont(getAddonDefaultFont(),12,"OUTLINE")
    getglobal(slider:GetName() .. 'High'):SetFont(getAddonDefaultFont(),12,"OUTLINE")
    getglobal(slider:GetName() .. 'Text'):SetFont(getAddonDefaultFont(),12,"OUTLINE")
    
	slider:Show();
	
	slider:SetScript("OnValueChanged", function(self, value)
	
		local fullLabel = "";
		local formattedValue = string.format("%."..decimalPrecision.."f",value);
		if (label ~= "") then
			fullLabel = label .. " " .. formattedValue;
		else   
			fullLabel = formattedValue;
		end
	
		if (showEditBox == false) then
			txt:SetText( fullLabel );
		else 
			txt:SetText( label );
		end
        
		changeHandler(value);
		
		if (showEditBox == true) then
			editBox:SetText(formattedValue);
			editBox:HighlightText(0,0); 
			editBox:ClearFocus();
			--editBox:SetCursorPosition(0);
		end
	end)
    	
	return slider;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #











--[[
	function createSlider(params)
	local sliderDropReplacementConfig = {};
	sliderDropReplacementConfig.name = "alignmentIndex";
	sliderDropReplacementConfig.frameContainer = frame;
	sliderDropReplacementConfig.default = DCoordsVDB["MainBar"].alignmentIndex;
	sliderDropReplacementConfig.width = sliderWidth;
	sliderDropReplacementConfig.labels = {
		"Addon is aligned to the TOP LEFT",
		"Addon is aligned to the TOP",
		"Addon is aligned to the TOP RIGHT",
		"Addon is aligned to the LEFT",
		"Addon is aligned to the CENTER",
		"Addon is aligned to the RIGHT",
		"Addon is aligned to the BOTTOM LEFT",
		"Addon is aligned to the BOTTOM",
		"Addon is aligned to the BOTTOM RIGHT"
	};
	sliderDropReplacementConfig.x = px;
	sliderDropReplacementConfig.y = py;
	sliderDropReplacementConfig.changeHandler = alignmentIndexChangeHandler;
--]]

function createSliderDropReplacement(params)
    params.x = params.x +5;
	
	--local slider = {};
	params.labelCount = 0;
	for k,v in pairs(params.labels) do
		params.labelCount = params.labelCount +1;
	end
	
	params.nameWithRand = "slider" .. params.name .. tostring(math.random(99999999));
	params.slider = CreateFrame("Slider", params.name, params.frameContainer, "OptionsSliderTemplate");
	params.slider:ClearAllPoints();
	params.slider:SetPoint("TOPLEFT", params.x, params.y-20);
	params.slider:SetMinMaxValues(1,params.labelCount);
	params.slider:SetValue(params.selected);
    params.slider:SetOrientation('HORIZONTAL')
    params.slider:SetWidth(params.width);
    params.slider:SetHeight(18);
    params.slider:SetObeyStepOnDrag(true);
	params.slider:SetValueStep(1);
	
	--getglobal(name .. 'Low'):SetText(min);
	--getglobal(name .. 'High'):SetText(max);
    
	params.sliderCenterText = getglobal(params.slider:GetName() .. 'Text');
	params.sliderMinText = getglobal(params.slider:GetName() .. 'Low');
	params.sliderMaxText = getglobal(params.slider:GetName() .. 'High');
	
	params.sliderCenterText:SetText( params.labels[params.selected] );
	params.sliderMinText:SetText("");
	params.sliderMaxText:SetText("");
	    
    getglobal(params.slider:GetName() .. 'Low'):SetFont(getAddonDefaultFont(),12,"OUTLINE")
    getglobal(params.slider:GetName() .. 'High'):SetFont(getAddonDefaultFont(),12,"OUTLINE")
    getglobal(params.slider:GetName() .. 'Text'):SetFont(getAddonDefaultFont(),12,"OUTLINE")
    
	params.slider:Show();
	params.slider:SetScript("OnValueChanged", function(self, value)
        params.sliderCenterText:SetText( params.labels[value] );
        params.changeHandler(value);
	end)
    	
	return params;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #













-- TAINTED!!!! DO NOT USE
--[[
-- -- http://wowprogramming.com/snippets/Create_UI-styled_dropdown_menu_10
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	
	--log("name["..name.."] default = " .. default);
	local nameWithRand = name .. tostring(math.random(99999999));
	local dropDown = CreateFrame("Button", nameWithRand, frameContainer, "UIDropDownMenuTemplate");
	dropDown:ClearAllPoints();
	dropDown:SetPoint("TOPLEFT", x-16, y);
	dropDown:Show();
	
	function dropDown:SetSelected(index)
		UIDropDownMenu_SetSelectedID(self, index);
	end
	
	local function OnClick(self)
		--log("Selected index = " .. self:GetID());
		UIDropDownMenu_SetSelectedID(dropDown, self:GetID());
		--print(self:GetID());
		clickHandlerFunction(self:GetID());
	end
	
	local function DCoordsDropInit(self, level)
		local info = UIDropDownMenu_CreateInfo();
		for k,v in pairs(labels) do
			info = UIDropDownMenu_CreateInfo();
			info.text = v;
			info.value = v;
			info.func = OnClick;
			--toChat("level = " .. tostring(level));
			UIDropDownMenu_AddButton(info, level);
		end
	end
	
	UIDropDownMenu_Initialize(dropDown, DCoordsDropInit);
	UIDropDownMenu_SetWidth(dropDown, width-10);
	UIDropDownMenu_SetButtonWidth(dropDown, width+6); -- hit area is smaller
	UIDropDownMenu_SetSelectedID(dropDown, default);
	UIDropDownMenu_JustifyText(dropDown, "LEFT");
	
	return dropDown;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
--]]




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createButton(name,frameContainer,label,width,x,y,clickHandler)
	local btn = CreateFrame("button",name, frameContainer, "UIPanelButtonTemplate")
	btn:SetHeight(22)
	btn:SetWidth(width)
	btn:SetPoint("TOPLEFT", frameContainer, "TOPLEFT", x, y)
	btn:SetText(label)
	btn:SetScript("OnClick", clickHandler)
	return btn;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createLabel(name,frameContainer,text,size,r,g,b,a,justify,x,y)
	local txt = frameContainer:CreateFontString(name, "OVERLAY");
	txt:SetFont(getAddonDefaultFont(),size,"OUTLINE");
	txt:SetTextColor(r,g,b,a);
	txt:SetPoint("TOPLEFT", frameContainer, "TOPLEFT", x, y);
	txt:SetText(text);
	txt:SetJustifyH(justify);
	return txt;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #